import { isVue3 as _, h as R, Vue2 as Ve, computed as j, unref as ke, inject as ze, provide as Be, ref as x, onMounted as Pe, onUpdated as Me, defineComponent as Y, getCurrentInstance as He, watch as T, onBeforeUnmount as Ke } from "vue-demi";
import { mergeProps as Le, createApp as qe, getTransitionRawChildren as Ye, Text as Ge, withDirectives as Je, vShow as Qe, Teleport as Xe, cloneVNode as Ze, Transition as re } from "vue";
import { offset as et, shift as tt, flip as rt, autoPlacement as nt, arrow as ot } from "@floating-ui/core";
import { useManualEffect as at } from "@visoning/vue-floating-core";
import { FloatingCreatorProps as lt, FloatingCreator as st } from "@visoning/vue-floating-core/components";
import { useInteractionsContext as it, useClick as ct, useFocus as pt, useHover as ut } from "@visoning/vue-floating-interactions";
function A(e, t) {
  const r = {};
  for (let n = 0; n < t.length; n++) {
    const o = t[n];
    o in e && (r[o] = e[o]);
  }
  return r;
}
var ft = Object.defineProperty, dt = Object.defineProperties, vt = Object.getOwnPropertyDescriptors, ne = Object.getOwnPropertySymbols, yt = Object.prototype.hasOwnProperty, mt = Object.prototype.propertyIsEnumerable, oe = (e, t, r) => t in e ? ft(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, _t = (e, t) => {
  for (var r in t || (t = {}))
    yt.call(t, r) && oe(e, r, t[r]);
  if (ne)
    for (var r of ne(t))
      mt.call(t, r) && oe(e, r, t[r]);
  return e;
}, gt = (e, t) => dt(e, vt(t));
const N = gt(_t({}, A(lt, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate"
])), {
  open: {
    type: Boolean,
    default: void 0
  },
  defaultOpen: Boolean,
  disabled: Boolean,
  virtualElement: Object,
  appendTo: {
    default: "body"
  },
  interactions: {
    type: Array,
    default: () => ["hover"]
  },
  delay: [Number, Object],
  clickDelay: [Number, Object],
  hoverDelay: [Number, Object],
  focusDelay: [Number, Object],
  keepOpenWhenPopupHover: {
    type: Boolean,
    default: !0
  },
  closeWhenClickOutside: {
    type: Boolean,
    default: !0
  },
  autoUpdateOnClosed: Boolean,
  offset: [Number, Object, Function],
  shift: {
    type: [Boolean, Object],
    default: !0
  },
  flip: [Boolean, Object],
  autoPlacement: [Boolean, Object],
  gpuAcceleration: Boolean,
  destoryedOnClosed: Boolean,
  referenceProps: Object,
  popupProps: Object,
  popupWrapper: Function,
  floatingWrapper: Function,
  zIndex: Number,
  "onUpdate:open": Function,
  onOpen: Function,
  onClose: Function,
  onFloatingDataUpdate: Function
}), Ot = /^on[^a-z]/, I = (e) => Ot.test(e);
function G(e) {
  return I(e) && (e = e.replace(/^on-?/, ""), e = e.charAt(0).toLowerCase() + e.slice(1)), e;
}
function Pt(e) {
  return Object.entries(e).reduce((t, [r, n]) => (t[G(r)] = n, t), {});
}
const S = _ ? Le : (...e) => {
  const t = {};
  for (let r = 0; r < e.length; r++) {
    const n = e[r];
    for (const o in n)
      o === "class" ? t.class !== n.class && (t.class = $e([t.class, n.class])) : o === "style" ? t.style = be([t.style, n.style]) : I(o) ? Object.assign(t, J(t, n)) : o !== "" && (t[o] = n[o]);
  }
  return t;
};
function J(...e) {
  const t = {};
  for (let r = 0; r < e.length; r++) {
    const n = e[r];
    for (let o in n) {
      const l = t[o], d = n[o];
      d && l !== d && !(Q(l) && l.includes(d)) && (t[o] = l ? [].concat(l, d).flat() : d);
    }
  }
  return t;
}
const Q = Array.isArray, K = (e) => typeof e == "string", we = (e) => e !== null && typeof e == "object";
function be(e) {
  if (Q(e)) {
    const t = {};
    for (let r = 0; r < e.length; r++) {
      const n = e[r], o = K(n) ? $t(n) : be(n);
      if (o)
        for (const l in o)
          t[l] = o[l];
    }
    return t;
  } else {
    if (K(e))
      return e;
    if (we(e))
      return e;
  }
}
const wt = /;(?![^(]*\))/g, bt = /:(.+)/;
function $t(e) {
  const t = {};
  return e.split(wt).forEach((r) => {
    if (r) {
      const n = r.split(bt);
      n.length > 1 && (t[n[0].trim()] = n[1].trim());
    }
  }), t;
}
function $e(e) {
  let t = "";
  if (K(e))
    t = e;
  else if (Q(e))
    t += e.map($e).join(" ");
  else if (we(e))
    for (const r in e)
      e[r] && (t += r + " ");
  return t.trim();
}
var ht = Object.defineProperty, jt = Object.defineProperties, xt = Object.getOwnPropertyDescriptors, ae = Object.getOwnPropertySymbols, Ct = Object.prototype.hasOwnProperty, Et = Object.prototype.propertyIsEnumerable, le = (e, t, r) => t in e ? ht(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, St = (e, t) => {
  for (var r in t || (t = {}))
    Ct.call(t, r) && le(e, r, t[r]);
  if (ae)
    for (var r of ae(t))
      Et.call(t, r) && le(e, r, t[r]);
  return e;
}, Dt = (e, t) => jt(e, xt(t));
function O(e, t, r) {
  r = Array.isArray(r) ? r : [r];
  let n = t.propsKey;
  if (!n && !_) {
    if (typeof e == "string") {
      const c = R(e);
      typeof c.tag == "string" && c.tag.indexOf("vue-component") !== 0 && (n = "attrs");
    }
    n || (n = "props");
  }
  const { data: o, scopedSlots: l } = t;
  if (_)
    return R(e, o, l ? Dt(St({}, l), {
      default: (...c) => {
        var D;
        return r.concat((D = l.default) == null ? void 0 : D.call(l, ...c));
      }
    }) : r);
  const d = [
    "key",
    "ref",
    "tag",
    "class",
    "style",
    "directives",
    "slots",
    "scopedSlots"
  ], p = {};
  "attrs" in o && (p.attrs = o.attrs);
  for (const c in o)
    I(c) ? p.on = J(p.on, {
      [G(c)]: o[c]
    }) : d.includes(c) ? p[c] = o[c] : (p[n] || (p[n] = {}))[c] = o[c];
  if (l)
    for (const c in l)
      (p.scopedSlots || (p.scopedSlots = {}))[c] = l[c];
  return R(e, p, r);
}
const Rt = (e) => {
  const t = {};
  if (_) {
    const n = qe(e);
    let o;
    return t.mount = (l) => o = n.mount(l || document.createElement("div")), t.unmount = () => n.unmount(), Object.defineProperties(t, {
      $el: {
        configurable: !0,
        get() {
          return o == null ? void 0 : o.$el;
        }
      },
      isMounted: {
        configurable: !0,
        get() {
          return !!(o != null && o.isMounted);
        }
      }
    }), t;
  }
  const r = new Ve(e);
  return t.mount = (n) => r.$mount(n), t.unmount = () => {
    r.$destroy(), r.$el.remove();
  }, Object.defineProperties(t, {
    $el: {
      configurable: !0,
      get() {
        return r.$el;
      }
    },
    isMounted: {
      configurable: !0,
      get() {
        return r._isMounted;
      }
    }
  }), t;
};
function Ft(...e) {
  return j(() => {
    const t = {};
    for (let r = 0; r < e.length; r++) {
      const n = ke(e[r]);
      t.floating = S(t.floating, n.floating), t.reference = S(t.reference, n.reference);
    }
    return t;
  });
}
const At = _ ? (e) => Ye(e, !1) : (e) => e.filter((t) => !t.isComment), It = _ ? (e) => e.type === Ge || e.type === "svg" || typeof e != "object" : (e) => !e.tag, Tt = (e) => e && !It(e) ? e : O("span", {
  data: {
    class: "visoning-text-wrapper"
  }
}, [e]), X = Symbol("ForwardReferenceInjectionKey"), se = {}, he = () => {
  const e = ze(X, se);
  return e === se ? void 0 : e;
}, $r = () => {
  const e = he();
  if (!e)
    throw new Error(`injection "${String(X)}" not found; please ensure the component is wrapped in a <Provider>`);
  return e;
}, Wt = (e) => {
  Be(X, e);
}, Ut = (e) => {
  const t = e || x(null);
  return Wt({
    forwardReference: (r) => t.value = r
  }), t;
}, je = (e) => Boolean(e && e.nodeType === 1);
function Nt(e) {
  const t = x(null);
  let r;
  return _ ? r = () => {
    const n = e == null ? void 0 : e.vnode;
    t.value = n && L([n]) || null;
  } : r = () => {
    var n;
    const o = (n = e == null ? void 0 : e.proxy) == null ? void 0 : n.$el;
    t.value = je(o) ? o : null;
  }, Pe(r), Me(r), t;
}
function L(e) {
  var t, r;
  for (let n = 0; n < e.length; n++) {
    const o = e[n];
    if (!(o.type === Comment || o.type === Text)) {
      if (je(o.el))
        return o.el;
      if (o.shapeFlag & 6 && ((t = o.component) == null ? void 0 : t.subTree))
        return L([(r = o.component) == null ? void 0 : r.subTree]);
      if (Array.isArray(o.children))
        return L(o.children);
    }
  }
}
var Vt = Object.defineProperty, kt = Object.defineProperties, zt = Object.getOwnPropertyDescriptors, V = Object.getOwnPropertySymbols, xe = Object.prototype.hasOwnProperty, Ce = Object.prototype.propertyIsEnumerable, ie = (e, t, r) => t in e ? Vt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, ce = (e, t) => {
  for (var r in t || (t = {}))
    xe.call(t, r) && ie(e, r, t[r]);
  if (V)
    for (var r of V(t))
      Ce.call(t, r) && ie(e, r, t[r]);
  return e;
}, Bt = (e, t) => kt(e, zt(t)), Mt = (e, t) => {
  var r = {};
  for (var n in e)
    xe.call(e, n) && t.indexOf(n) < 0 && (r[n] = e[n]);
  if (e != null && V)
    for (var n of V(e))
      t.indexOf(n) < 0 && Ce.call(e, n) && (r[n] = e[n]);
  return r;
};
const pe = {
  popup: "visoning-popup",
  floating: "visoning-floating"
}, Ht = Y({
  name: "VisoningPopup",
  inheritAttrs: !_,
  props: N,
  setup(e, { emit: t, slots: r, expose: n }) {
    const o = x(!!e.defaultOpen), l = j(() => e.open === void 0 ? o.value : e.open), d = (a, i) => {
      o.value = a, a !== e.open && (t("update:open", a, i), t(a ? "open" : "close", i));
    }, p = He(), c = Nt(p), D = Ut(), s = j(() => c.value || D.value), u = he();
    u && T(s, () => u.forwardReference(s.value));
    const P = j(() => e.virtualElement || s.value), g = x(), v = it(P, g);
    T(v.open, (a) => {
      d(a, v.info.value);
    }), T(l, (a) => {
      v.open.value !== a && v.setOpen(a, {
        type: "component"
      });
    });
    const b = (a) => e.interactions.includes(a), $ = Ft(ut(v, j(() => {
      var a;
      return {
        disabled: !b("hover"),
        delay: (a = e.hoverDelay) != null ? a : e.delay,
        keepOpenWhenPopupHover: !!e.keepOpenWhenPopupHover
      };
    })), pt(v, j(() => {
      var a;
      return {
        disabled: !b("focus"),
        delay: (a = e.focusDelay) != null ? a : e.delay
      };
    })), ct(v, j(() => {
      var a;
      return {
        disabled: !b("click"),
        delay: (a = e.clickDelay) != null ? a : e.delay,
        closeWhenClickOutside: !!e.closeWhenClickOutside
      };
    })), {
      floating: e.popupProps,
      reference: e.referenceProps
    }), h = x();
    n({
      getFloatingData: () => {
        var a;
        return (a = h.value) == null ? void 0 : a.getFloatingData();
      },
      updatePosition: () => {
        var a;
        return (a = h.value) == null ? void 0 : a.updatePosition();
      }
    });
    const F = (a, i = {}) => typeof a == "object" ? a : i, z = j(() => {
      const a = [];
      return e.offset && a.push(et(e.offset)), e.shift && a.push(tt(F(e.shift))), e.flip && a.push(rt(F(e.flip))), e.autoPlacement && a.push(nt(F(e.autoPlacement))), a.concat(e.middleware || []);
    }), Ae = (a) => {
      var i;
      const { value: y } = l;
      if (!y && e.destoryedOnClosed)
        return;
      let m = O("div", {
        data: S($.value.floating, {
          class: pe.popup
        })
      }, (i = r.default) == null ? void 0 : i.call(r, a));
      if (_)
        Je(m, [[Qe, y, "show"]]);
      else {
        const w = {
          name: "show",
          value: y
        };
        (m.data.directives || (m.data.directives = [])).push(w);
      }
      const { popupWrapper: f } = e;
      return f ? f(m) : m;
    }, B = x(null);
    if (!_) {
      const a = () => {
        const m = Rt({
          render() {
            return B.value;
          }
        });
        m.mount();
        const { appendTo: f } = e;
        return (typeof f == "string" ? document.querySelector(f) : f).appendChild(m.$el), m.unmount;
      }, { clear: i, reset: y } = at(a);
      T(() => e.appendTo, (m) => {
        m ? y() : i();
      }), Pe(y), Ke(i);
    }
    const Ie = (a) => e.gpuAcceleration ? {
      position: a.strategy,
      top: 0,
      left: 0,
      transform: `translate3d(${a.x}px, ${a.y}px, 0px)`,
      zIndex: e.zIndex
    } : {
      position: a.strategy,
      top: `${a.y}px`,
      left: `${a.x}px`,
      zIndex: e.zIndex
    }, Te = (a, i) => {
      let y = O("div", {
        data: {
          ref: g,
          class: pe.floating,
          style: Ie(a)
        }
      }, [i]);
      if (e.floatingWrapper && (y = e.floatingWrapper(y)), B.value = null, !e.appendTo)
        return y;
      if (_)
        return O(Xe, {
          data: {
            to: e.appendTo
          },
          scopedSlots: {
            default: () => [y]
          }
        });
      B.value = y;
    }, We = (a, i) => {
      var y;
      const m = r.reference && At(r.reference(a));
      if (!m)
        return;
      let f = Tt(m[0]);
      if (_)
        return f = Ze(f, ce({}, S((y = p == null ? void 0 : p.proxy) == null ? void 0 : y.$attrs, $.value.reference))), [f, i];
      {
        const w = f.data || (f.data = {}), Z = S(Bt(ce({}, w.attrs), {
          class: w.class,
          style: w.style
        }), $.value.reference), {
          class: Ue,
          style: Ne
        } = Z, M = Mt(Z, [
          "class",
          "style"
        ]), ee = {}, te = {};
        for (const E in M)
          I(E) ? ee[E] = M[E] : te[E] = M[E];
        w.class = Ue, w.style = Ne, w.attrs = te, w.on = J(w.on, Pt(ee)), i && (f.children = (Array.isArray(f.children) ? f.children : [f.children]).filter((E) => E != null).concat(i));
      }
      return f;
    };
    return () => {
      const a = e.disabled || !l.value && !e.autoUpdateOnClosed;
      return O(st, {
        data: {
          ref: h,
          reference: P.value,
          floating: g.value,
          disabled: a,
          placement: e.placement,
          strategy: e.strategy,
          middleware: z.value,
          autoUpdate: e.autoUpdate,
          onUpdate: (i) => t("floating-data-update", i)
        },
        scopedSlots: {
          default: (i) => We(i, Te(i, Ae(i)))
        }
      });
    };
  }
});
function q(e) {
  return Array.isArray(e) ? !e.length : e == null;
}
function Ee(e, t) {
  return t.reduce((r, n) => {
    const o = G(n), l = I(n) ? n : `on${o.charAt(0).toUpperCase()}${o.slice(1)}`;
    return r[l] = (...d) => e(o, ...d), r;
  }, {});
}
var Kt = Object.defineProperty, Lt = Object.defineProperties, qt = Object.getOwnPropertyDescriptors, ue = Object.getOwnPropertySymbols, Yt = Object.prototype.hasOwnProperty, Gt = Object.prototype.propertyIsEnumerable, fe = (e, t, r) => t in e ? Kt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, Se = (e, t) => {
  for (var r in t || (t = {}))
    Yt.call(t, r) && fe(e, r, t[r]);
  if (ue)
    for (var r of ue(t))
      Gt.call(t, r) && fe(e, r, t[r]);
  return e;
}, Jt = (e, t) => Lt(e, qt(t));
const De = Se({}, A(N, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "interactions",
  "delay",
  "clickDelay",
  "hoverDelay",
  "focusDelay",
  "keepOpenWhenPopupHover",
  "closeWhenClickOutside",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "referenceProps",
  "floatingWrapper",
  "zIndex",
  "onUpdate:open",
  "onOpen",
  "onClose",
  "onFloatingDataUpdate"
])), k = Jt(Se({}, De), {
  content: [String, Object],
  title: [String, Object],
  theme: {
    type: String,
    default: "light"
  },
  transitionProps: {
    type: [String, Object],
    default: "visoning-popover"
  },
  showArrow: {
    type: Boolean,
    default: !0
  },
  arrow: [Object, Function],
  arrowProps: Object,
  popoverProps: N.popupProps,
  popoverWrapper: N.popupWrapper
});
var Qt = Object.defineProperty, Xt = Object.defineProperties, Zt = Object.getOwnPropertyDescriptors, de = Object.getOwnPropertySymbols, er = Object.prototype.hasOwnProperty, tr = Object.prototype.propertyIsEnumerable, ve = (e, t, r) => t in e ? Qt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, W = (e, t) => {
  for (var r in t || (t = {}))
    er.call(t, r) && ve(e, r, t[r]);
  if (de)
    for (var r of de(t))
      tr.call(t, r) && ve(e, r, t[r]);
  return e;
}, rr = (e, t) => Xt(e, Zt(t));
const U = "visoning-popover", nr = Y({
  name: "VisoningPopover",
  props: k,
  setup(e, { emit: t, slots: r }) {
    const n = x(), o = x(), l = ({ placement: s, middlewareData: u }) => {
      var P, g, v, b;
      const $ = (g = (P = u.arrow) == null ? void 0 : P.y) != null ? g : 0, h = (b = (v = u.arrow) == null ? void 0 : v.x) != null ? b : 0, C = {
        "--vp-arrow-top": `${$}px`,
        "--vp-arrow-left": `${h}px`
      };
      return s.includes("top") || s.includes("bottom") ? C.left = `${h}px` : C.top = `${$}px`, C;
    }, d = (s) => {
      const u = e.arrow || r.arrow;
      return u ? typeof u == "function" ? u(s) : u : O("div", {
        data: {
          ref: o,
          class: `${U}-arrow`,
          style: l(s)
        }
      });
    }, p = j(() => {
      const s = e.middleware || [];
      return e.showArrow && o.value && s.push(ot({
        element: o.value
      })), s;
    }), c = (s) => {
      const { transitionProps: u, popoverWrapper: P } = e;
      if (u) {
        const g = typeof u == "string" ? { name: u } : u;
        if (_) {
          const v = s;
          s = O(re, {
            data: g,
            scopedSlots: {
              default: () => v
            }
          });
        } else
          s = O(_ ? re : "transition", {
            data: g
          }, [s]);
      }
      return typeof P == "function" ? P(s) : s;
    }, D = (s) => {
      var u, P, g, v, b;
      const { showArrow: $ } = e, h = (P = e.title) != null ? P : (u = r.title) == null ? void 0 : u.call(r), C = (v = e.content) != null ? v : (g = r.content) == null ? void 0 : g.call(r), F = !q(h), z = !q(C);
      return O("div", {
        data: W({}, S(e.popoverProps, {
          class: [
            U,
            {
              "with-arrow": $,
              dark: e.theme === "dark"
            }
          ],
          "data-placement": s.placement
        }))
      }, [
        R("div", {
          class: `${U}-content`
        }, [
          F ? R("div", {
            class: `${U}-title`
          }, [h]) : null,
          z ? C : (b = r.default) == null ? void 0 : b.call(r)
        ]),
        $ && d(s)
      ]);
    };
    return () => {
      const s = W(W({}, A(e, Object.keys(De))), Ee(t, ["onUpdate:open", "open", "close", "onFloatingDataUpdate"]));
      return O(Ht, {
        data: rr(W({}, s), {
          ref: n,
          middleware: p.value,
          popupWrapper: c
        }),
        scopedSlots: {
          reference: r.reference,
          default: D
        }
      });
    };
  }
});
var or = Object.defineProperty, ar = Object.defineProperties, lr = Object.getOwnPropertyDescriptors, ye = Object.getOwnPropertySymbols, sr = Object.prototype.hasOwnProperty, ir = Object.prototype.propertyIsEnumerable, me = (e, t, r) => t in e ? or(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, Re = (e, t) => {
  for (var r in t || (t = {}))
    sr.call(t, r) && me(e, r, t[r]);
  if (ye)
    for (var r of ye(t))
      ir.call(t, r) && me(e, r, t[r]);
  return e;
}, cr = (e, t) => ar(e, lr(t));
const Fe = Re({}, A(k, [
  "placement",
  "strategy",
  "middleware",
  "autoUpdate",
  "open",
  "defaultOpen",
  "disabled",
  "virtualElement",
  "appendTo",
  "delay",
  "clickDelay",
  "hoverDelay",
  "focusDelay",
  "keepOpenWhenPopupHover",
  "closeWhenClickOutside",
  "autoUpdateOnClosed",
  "offset",
  "shift",
  "flip",
  "autoPlacement",
  "gpuAcceleration",
  "destoryedOnClosed",
  "referenceProps",
  "floatingWrapper",
  "zIndex",
  "onUpdate:open",
  "onOpen",
  "onClose",
  "onFloatingDataUpdate"
])), pr = cr(Re({}, Fe), {
  content: [String, Object],
  textAlign: {
    type: String,
    default: "start"
  },
  tooltipProps: k.popoverProps,
  tooltipWrapper: k.popoverWrapper
});
var ur = Object.defineProperty, fr = Object.defineProperties, dr = Object.getOwnPropertyDescriptors, _e = Object.getOwnPropertySymbols, vr = Object.prototype.hasOwnProperty, yr = Object.prototype.propertyIsEnumerable, ge = (e, t, r) => t in e ? ur(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, H = (e, t) => {
  for (var r in t || (t = {}))
    vr.call(t, r) && ge(e, r, t[r]);
  if (_e)
    for (var r of _e(t))
      yr.call(t, r) && ge(e, r, t[r]);
  return e;
}, mr = (e, t) => fr(e, dr(t));
const Oe = "visoning-tooltip", hr = Y({
  name: "Tooltip",
  props: pr,
  setup(e, { emit: t, slots: r }) {
    const n = () => {
      var o, l, d;
      const p = (l = e.content) != null ? l : (o = r.content) == null ? void 0 : o.call(r), c = !q(p);
      return O("div", {
        data: {
          style: {
            textAlign: e.textAlign
          }
        }
      }, [
        R("span", {
          class: `${Oe}-content`
        }, [c ? p : (d = r.default) == null ? void 0 : d.call(r)])
      ]);
    };
    return () => {
      const o = H(H({}, A(e, Object.keys(Fe))), Ee(t, ["onUpdate:open", "open", "close", "onFloatingDataUpdate"]));
      return O(nr, {
        data: mr(H({}, o), {
          interactions: ["hover"],
          popoverProps: S(e.tooltipProps, {
            class: Oe
          }),
          popoverWrapper: e.tooltipWrapper
        }),
        scopedSlots: {
          reference: r.reference,
          arrow: r.arrow,
          content: n
        }
      });
    };
  }
});
export {
  nr as Popover,
  De as PopoverExtendsPopupProps,
  k as PopoverProps,
  Ht as Popup,
  N as PopupProps,
  hr as Tooltip,
  Fe as TooltipExtendsPopoverProps,
  pr as TooltipProps,
  Ut as createReferenceForwardContext,
  Wt as providePopupContextValue,
  $r as useReferenceForwardContext,
  he as useSafeReferenceForwardContent
};
